/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: setpassword
 * CMDALIASES: setpass
 * CMDLEVEL: QCMD_OPER
 * CMDARGS: 3
 * CMDDESC: Set a new password.
 * CMDFUNC: csa_dosetpw
 * CMDPROTO: int csa_dosetpw(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: @UCOMMAND@ <username> <password> <reason for use>
 * CMDHELP: Sets the password for the specified username.
 */

#include "../chanserv.h"
#include "../authlib.h"
#include "../../lib/irc_string.h"
#include <stdio.h>
#include <string.h>

int csa_dosetpw(void *source, int cargc, char **cargv) {
  nick *sender=source;
  reguser *rup, *vrup=getreguserfromnick(sender);
  char *reason;

  if (cargc<3) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "setpassword");
    return CMD_ERROR;
  }

  if (!(rup=findreguser(sender, cargv[0])))
    return CMD_ERROR;

  reason = cargv[2];
  if(!checkreason(sender, reason))
    return CMD_ERROR;

  if(UHasStaffPriv(rup)) {
    cs_log(sender,"GETPASSWORD FAILED username %s (reason: %s)",rup->username, reason);
    chanservwallmessage("%s (%s) just FAILED using SETPASSWORD on %s (reason: %s)", sender->nick, vrup->username, rup->username, reason);
    chanservsendmessage(sender, "Sorry, that user is privileged.");
    return CMD_ERROR;
  }

  cs_log(sender,"SETPASSWORD OK username %s (reason: %s)",rup->username, reason);
  chanservwallmessage("%s (%s) just used SETPASSWORD on %s (reason: %s)", sender->nick, vrup->username, rup->username, reason);

  if(rup->lastemail) {
    freesstring(rup->lastemail);
    rup->lastemail=NULL;
  }
  rup->lockuntil=0;

  csdb_accounthistory_insert(sender, rup->password, cargv[1], NULL, NULL);
  setpassword(rup, cargv[1]);
  csdb_updateuser(rup);

  chanservstdmessage(sender, QM_PWCHANGED);

  return CMD_OK;
}
