/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: unsuspendchan
 * CMDLEVEL: QCMD_OPER
 * CMDARGS: 2
 * CMDDESC: Unsuspends a channel from the bot.
 * CMDFUNC: csc_dounsuspendchan
 * CMDPROTO: int csc_dounsuspendchan(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: unsuspendchan <channel> <reason>
 * CMDHELP: Unsuspends specified channel.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include <string.h>
#include <stdio.h>

int csc_dounsuspendchan(void *source, int cargc, char **cargv) {
  nick *sender=source;
  reguser *rup=getreguserfromnick(sender);
  chanindex *cip;
  regchan *rcp;
  reguser *suspendedby;
  char *csuspendedby, *csuspendedreason;
  char *unsuspendreason;

  if (!rup)
    return CMD_ERROR;

  if (cargc<2) {
    chanservstdmessage(sender, QM_NOTENOUGHPARAMS, "unsuspendchan");
    return CMD_ERROR;
  }

  unsuspendreason = cargv[1];
  if(!checkreason(sender, unsuspendreason))
    return CMD_ERROR;

  if (!(cip=findchanindex(cargv[0])) || !(rcp=cip->exts[chanservext])) {
    chanservstdmessage(sender, QM_UNKNOWNCHAN, cargv[0]);
    return CMD_ERROR;
  }

  if(!CIsSuspended(rcp)) {
    chanservstdmessage(sender, QM_CHANNELNOTSUSPENDED, cip->name->content);
    cs_log(sender,"UNSUSPENDCHAN %s is not suspended",cip->name->content);
    return CMD_ERROR;
  }

  CClearSuspended(rcp);

  suspendedby = findreguserbyID(rcp->suspendby);
  csuspendedby = suspendedby?suspendedby->username:"(unknown)";
  csuspendedreason = rcp->suspendreason?rcp->suspendreason->content:"(no reason)";

  chanservwallmessage("%s (%s) used UNSUSPENDCHAN on %s (suspended by: %s, suspension reason: %s), unsuspension reason: %s", sender->nick, rup->username, cip->name->content, csuspendedby, csuspendedreason, unsuspendreason);
  cs_log(sender,"UNSUSPENDCHAN %s (suspended by: %s, suspension reason: %s), unsuspension reason: %s", cip->name->content, csuspendedby, csuspendedreason, unsuspendreason);

  freesstring(rcp->suspendreason);
  rcp->suspendreason = NULL;
  rcp->suspendby = 0;

  if(cip->channel)
    chanservjoinchan(cip->channel);

  csdb_updatechannel(rcp);
  chanservstdmessage(sender, QM_DONE);

  return CMD_OK;
}
